<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 3.0.00  
* Copyright (C) 2007-2011: Fred Stuurman (fc.stuurman@gmail.com)
* Mailpage module: 
* mailpage.php: last changed 15/09/2011 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}
$lang = strtolower($language);
if (!file_exists("starnet/interface/jquery/localization/messages_$lang.js"))
{
	$lang = "en" ;
}
?>
<link rel="stylesheet" type="text/css" href="starnet/interface/css-form.css" />
<script>
//check if jquery is already loaded, if not load it
if(typeof jQuery == 'undefined') {
document.write('<script type="text/javascript" src="starnet/interface/jquery/jquery.js"></'+'script>');
var __noconflict = true;
}
</script>
<script src="starnet/interface/jquery/jquery.validate_en.js" type="text/javascript"></script>
<script src="starnet/interface/jquery/localization/messages_<?php echo strtolower($lang) ?>.js" type="text/javascript"></script>
<script type="text/javascript">
$(document).ready(function() {
	$("#theForm").validate({
	  errorLabelContainer: "#ErrorBox",
	  groups: {group1:"fullname email subject message"},
	  rules: {
		fullname: {
		  required: true,
		  rangelength: [2, 60]
		},
		email: {
		  required: true,
		  email: true
		},
		subject: {
		  required: true,
		  rangelength: [4, 80]
		},
		message: {
		  required: true,
		  rangelength: [10, 3000]
		}
	}
  })
});
</script> 
<?php

//initialize vars
$fullname = "";
$message = "";
$email = "";
$modoption = "show_form";	//default choice for switch
$ip = $_SERVER["REMOTE_ADDR"];

if (IsSet ($_GET['modoption']))
{
	$modoption = sanitize($_GET['modoption'], 15, 'A');
}

//id used for the dropdown selection menu to select the contact person
if (IsSet ($_GET['contact_id']))
{
	$contact_id = sanitize($_GET['contact_id'], 5 , 'I');
}

if (IsSet ($_POST['fullname']))
{
	$fullname = sanitize($_POST['fullname'], 60 , 'S'); //sanitize the input
}

if (IsSet ($_POST['message']))
{
	$message = sanitize($_POST['message'], 3000 , 'S'); //sanitize the input
}

if (IsSet ($_POST['email']))
{
	$email = sanitize($_POST['email'], 80 , 'A'); //sanitize the input, max 80 characters
	$email = explode(",", $email); //if more than one email is entered
	$email = str_replace(array("\n", "\r"), "", $email[0]); //ony use the first one.
}

$table_email_adresses = $dbprefix . "m_mail_address";

load_language($cmsdir . '/', 'sn_mailpage'); //load language file

if (IsSet ($contact_id))
{
	$query = "SELECT name, description, email, welcometext, thankyoutext, id " .
			"FROM $table_email_adresses WHERE id = '".$contact_id."'";
}
else
{
	$query = "SELECT name, description, email, welcometext, thankyoutext, id " .
			"FROM $table_email_adresses ORDER BY sort LIMIT 1";
}

$result = mysql_query($query) or trigger_error(mysql_error().'"<br/>Query : "' . $query . '".',E_USER_WARNING); 
$RecordCount = mysql_num_rows($result);

if ($RecordCount > 0)
{ //if table is empty use old email from config table
	$contact_name = mysql_result($result, 0, 0); //address from config table.
	$contact_description = mysql_result($result, 0, 1);
	$contact_email = mysql_result($result, 0, 2);
	$contact_welcome_text = mysql_result($result, 0, 3);
	$contact_thankyou_text = mysql_result($result, 0, 4);
	$contact_id = mysql_result($result, 0, 5);
}
else
{
	$contact_name = "";
	$contact_description = "";
	$contact_email = $sas_config['email'];
	$contact_welcome_text = $sas_config['email_text'];
	$contact_thankyou_text = $sas_config['email_thankyou_text'];
}
unset ($query);
unset ($result);

switch ($modoption) // start of switch
{
	case send_email :
		
		//try to prevent spam postings
		//if the submit_check_code stored in the session is equal to the one submitted
		//we allow submission
		if ($_POST['submit_check_code'] != $_SESSION['submit_check_code'] || !empty($_POST['leegt']) || $_POST[$_SESSION['somfield']] != ((int)$_SESSION['som1'] + (int)$_SESSION['som2'])) 
		{
		   print "<span class=\"sas_module_error\">".$sas_lang['invalid_submission']."</span>";
		   print "<input type=\"button\" value=\"" . $sas_lang['goback'] . "\" name=\"backbutton\" 
				onClick=\"javascript:history.go(-1)\" class=\"backbutton\">";
		   exit;
		}
		
		$submitted_time_key = $pagetitle . "_submitted_time";
		if (IsSet ($_SESSION[$submitted_time_key]))
		{
			//we have had a previous submit from this session and page
			//calculate how many seconds ago and
			//allow submission if the last submission is not longer than 5 minutes ago.
			$delta_time = time() - $_SESSION[$submitted_time_key] ; 
			if ($delta_time < 300)
			{
				print "<span class=\"sas_module_error\">".$sas_lang['invalid_submission']."</span>";
				print "<input type=\"button\" value=\"" . $sas_lang['goback'] . "\" name=\"backbutton\" 
					onClick=\"javascript:history.go(-1)\" class=\"backbutton\">";
				exit;
			}
		}

		$send_message = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"
					\"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">
					<html>
					<head>
					<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . $sas_lang['lang_charset'] . "\">
					<title>".$sas_lang['email_module_email']."</title>
					</head>
					<body>
					<table>
					<tr><td><b>".$sas_lang['email_module_to'].":</b></td><td>$contact_name</td></tr>
					<tr><td width='8%'><b>".$sas_lang['email_module_name']."</b></td><td>$fullname</td></tr>
					<tr><td><b>".$sas_lang['email_module_email']."</td><td>$email</td></tr>
					<tr><td valign=\"top\"><b>".$sas_lang['email_module_text']."</b></td><td>$message</td></tr>
					<tr><td valign=\"top\"><b>IP:</td><td>$ip</b></td></tr>
					</table><br/><br/>
					</body></html>";

		require ($cmsdir."/core/class.phpmailer.php"); //use the phpmailer class
		$mail = new PHPMailer();
		$mail->CharSet = $sas_lang['lang_charset'] ;
		$mail->From = $email; //email address of submitter
		$mail->FromName = $sitename;
		$mail->Subject = $sas_lang['email_module_email_from'] . " " . $fullname . " - $email";
		$mail->Body = $send_message;
		$mail->IsHTML(true);
		$mail->AddAddress($contact_email); //add email address owner form.
		$mail->Send();

		//put submitted data in a session vars to display the result page.
		$_SESSION['submitted_contact_name'] = $contact_name ;
		$_SESSION['submitted_email'] = $email ;
		$_SESSION['submitted_message'] = $message ;
		$_SESSION['submitted_full_name'] = $fullname ;

		unset($_SESSION['security_code']); //clear the code so it cannot be used again!
		$_SESSION[$submitted_time_key] = time(); //record the time of this submission for this page
		//go to display the result page
		print "<script type=\"text/javascript\">window.location = 'index.php?section=$section&page=$page&modoption=display_result'</script>";

	break;

	case display_result :
	
		print 
			"<table class=\"sas_module_table\"><tr>
			<td colspan=\"3\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_sent_us']."</span></td>
			</tr>
			<tr>
			<td colspan=\"3\">&nbsp;</td></tr>
			<tr>
			<td width='25%'><span class=\"sas_module_lbl1\">".$sas_lang['email_module_to'].":</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_contact_name']."</span></td>
			</tr><tr>
			<td><span class=\"sas_module_lbl1\">".$sas_lang['email_module_name']."</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_full_name']."</span></td>
			</tr><tr>
			<td><span class=\"sas_module_lbl1\">".$sas_lang['email_module_email']."</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_email']."</span></td>
			</tr><tr>
			<td valign=\"top\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_text']."</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_message']."</span></td>
			</tr>
			</table><br/><br/><span class=\"sas_module_subtitle\">";
			
		if ($contact_thankyou_text == "")
		{
			print $sas_config['email_thankyou_text'];
		}
		else
		{
			print $contact_thankyou_text;
		}
		unset($_SESSION['submitted_message']);	//clear session variable
		unset($_SESSION['submitted_contact_name']);
		unset($_SESSION['submitted_email']);
		unset($_SESSION['submitted_full_name']);
		
		print "</span><br/><br/><form action=\"\">
				<input type=\"button\" value=\"".$sas_lang['goback']."\" name=\"backbutton\"
				onclick=\"parent.location='index.php?section=$section&amp;page=$page'\" class=\"backbutton\"/></form>";
	break;
	
	case show_form :
	
		//set a code in a session var which is checked at submit time.
		$submit_check_code = random_code(10) ;
		$_SESSION['submit_check_code'] = $submit_check_code ;
		
		$query = "SELECT id, name, description FROM $table_email_adresses ORDER BY sort";
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br/>Query : "' . $query . '".',E_USER_WARNING); 
		$RecordCount = mysql_num_rows($result);
	
		print "
<script type=\"text/javascript\">
<!--
	function ViewCrossReference (selSelectObject){
		if (selSelectObject.options[selSelectObject.selectedIndex].value != '')
		{
		location.href=selSelectObject.options[selSelectObject.selectedIndex].value
		}
	}

function checkLen(Target) 
{
	StrLen = Target.value.length;
	document.getElementById('chars').innerHTML = 3000 - StrLen;
	
}
//-->
</script>";
	
		print "\n";
		if ($contact_welcome_text == "")
		{
			print $sas_config['email_text'];
		}
		else
		{
			print $contact_welcome_text;
		}
		
		print "<br clear=\"all\" />$contact_description
				<br clear=\"all\" />
				<div id=\"ErrorBox\"></div>";
		print "\n<div id=\"theform\">
				<form name=\"theForm\" id=\"theForm\" style=\"width: 500px;\" method=\"post\" action=\"index.php?section=$section&amp;page=$page&amp;contact_id=$contact_id&amp;modoption=send_email\" />
				<ol>";
	
		if ($RecordCount > 1)
		{
			print "  <li style=\"width: 488px;\">
				  <label style=\"width: 170px;\"><span class=\"sas_module_lbl1\">" . $sas_lang['email_module_select_contact'] . 
					":</span></label><select name=\"contact_id_selected\" onchange=\"ViewCrossReference(this);\">";
			
			while ($address_list = mysql_fetch_array($result))
			{
				if ($contact_name == $address_list[1])
				{
					print "<option value=\"index.php?section=$section&amp;page=$page&amp;contact_id=$address_list[0]\" selected=\"selected\">$address_list[1]</option>";
				}
				else
				{
					print "<option value=\"index.php?section=$section&amp;page=$page&amp;contact_id=$address_list[0]\">$address_list[1]</option>";
				}
			}
			print "</select>
					</li>";
		}
		print "<li style=\"width: 488px;\">
				  <label style=\"width: 170px;\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_name']." (*)&nbsp;</span></label>
				  <input size=\"50\" name=\"fullname\" value=\"$fullname\" style=\"width: 270px;\" />
				</li>";

		print "<li style=\"width: 488px;\">
				  <label style=\"width: 170px;\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_email']." (*)&nbsp;</span></label>
				  <input size=\"50\" name=\"email\" value=\"$email\"  style=\"width: 270px;\"/>
				</li>
				<li style=\"width: 488px;\">
				  <label style=\"width: 170px;\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_subject']." (*)&nbsp;</span></label>
				  <input size=\"50\" name=\"subject\" value=\"$subject\"  style=\"width: 270px;\"/>
				  </li>
				<li style=\"width: 488px;\">
				  <label style=\"width: 170px;\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_text']." (*)&nbsp;</span></label>
				  <textarea name=\"message\" rows=\"9\" cols=\"40\" style=\"width: 270px;\" onFocus='checkLen(this);'
				   onKeydown='checkLen(this);' onKeyup='checkLen(this);' onKeyPress='checkLen(this);'
				   onBlur='checkLen(this);' onChange='checkLen(this);' onClick='checkLen(this);'>$message</textarea>
				   <p style=\"margin-left: 180px;\"><span class=\"sas_module_lbl2\">".$sas_lang['email_module_characters_to_type']."</span></p>";
				
			print "<p style=\"margin: 0 0 0 180px;\"><span class=\"sas_module_lbl2\">".$sas_lang['required_fields']."</span></p>
					 <input type=\"hidden\" name=\"contact_id\" id=\"contact_id\" value=\"$contact_id\"/>
					 <input type=\"hidden\" id=\"submit_check_code\" name=\"submit_check_code\" value=\"$submit_check_code\"/>
					 <input id=\"" . $_SESSION['somfield'] . "\" name=\"" . $_SESSION['somfield'] . "\" value=\"\" type=\"hidden\" />
					 <input type=\"hidden\" name=\"leegt\" value=\"\" /></li>
					 <li style=\"padding-left: 300px; width: 194px;\"><button type=\"submit\" class=\"button\"><em><span>" . $sas_lang['email_module_send'] . "</em></span></button></li>
				  </ol></form>
				  </div>";
		print '<script type="text/javascript">document.getElementById(\'' . $_SESSION['somfield'] . '\').value = \'' . ((int)$_SESSION['som1'] + (int)$_SESSION['som2']) . '\'; </script>';
	
	break;
}
?>