<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 3.0.00  
* Copyright (C) 2007-2011: Fred Stuurman (fc.stuurman@gmail.com)
* Core function:
* con_start.inc.php: last changed 01/08/2011 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

if (IsSet ($_GET['save']))
{
	$save = $_GET['save'];
}
if (IsSet ($_POST['fullname']))
{
	$fullname = sanitize($_POST['fullname'], 60, 'S');
}
if (IsSet ($_POST['username']))
{
	$username = sanitize($_POST['username'], 20, 'S');
}
if (IsSet ($_POST['password']))
{
	$password = sanitize($_POST['password'], 15, 'S');
}
if (IsSet ($_POST['email']))
{
	$email = sanitize($_POST['email'], 80, 'A');
}
if (IsSet ($_POST['newsiteemail']))
{
	$siteemail = sanitize($_POST['newsiteemail'], 80, 'A');
}
if (IsSet ($_POST['neweditor']))
{
	$neweditor = intval($_POST['neweditor']);
}
if (IsSet ($_POST['newtheme']))
{
	$newtheme = sanitize($_POST['newtheme'], 50, 'S');;
}
if (IsSet ($_POST['new_prot_theme']))
{
	$new_prot_theme = sanitize($_POST['new_prot_theme'], 50, 'S');
}
if (IsSet ($_POST['newsitename']))
{
	$newsitename = sanitize($_POST['newsitename'], 100, 'S');
}
if (IsSet ($_POST['newtagline']))
{
	$newtagline = sanitize($_POST['newtagline'], 500, 'S');
}
if (IsSet ($_POST['startsection']))
{
	$startsection = intval($_POST['startsection']);
}
if (IsSet ($_POST['sessioncode']))
{
	$sessioncode = sanitize($_POST['sessioncode'], 80, 'S');
}
if (IsSet ($_POST['siteurl']))
{
	$siteurl = sanitize($_POST['siteurl'], 100, 'S');
}
if (IsSet ($_POST['serverpath']))
{
	$serverpath = sanitize($_POST['serverpath'], 100, 'S');
}
if (IsSet ($_POST['userpath']))
{
	$userpath = sanitize($_POST['userpath'], 100, 'S');
}
if (IsSet ($_POST['newlanguage']))
{
	$newlanguage = sanitize($_POST['newlanguage'], 5, 'S');
}

if (IsSet ($_POST['newdateformat']))
{
	$newdateformat = sanitize($_POST['newdateformat'], 10, 'S');
}
if (IsSet ($_POST['editor_rows']))
{
	$editor_rows = intval($_POST['editor_rows']);
}
if (IsSet ($_POST['editor_width']))
{
	$editor_width = intval($_POST['editor_width']);
}
if (IsSet ($_POST['num_pages']))
{
	$num_pages = intval($_POST['num_pages']);
}
if (IsSet ($_POST['allow_javascript']))
{
	$allow_javascript = intval($_POST['allow_javascript']);
}
if (IsSet ($_POST['file_permissions']))
{
	$file_permissions = sanitize($_POST['file_permissions'], 4 , 'A');
}
if (IsSet ($_POST['valid_types']))
{
	$valid_types = $_POST['valid_types'];

	//remove blank entries from array
	foreach ($valid_types as $index => $value) 
	{
	   if (empty($value)) unset($valid_types[$index]);
	}
}
if (IsSet ($_POST['meta_keywords']))
{
	$meta_keywords = sanitize($_POST['meta_keywords'], 200, 'S');
}
if (IsSet ($_POST['meta_description']))
{
	$meta_description = sanitize($_POST['meta_description'], 500, 'S');
}

if (IsSet ($save))
{
	if ($save == "configuration")
	{
		mysql_query("UPDATE $table_configuration SET config_value = '$newtheme' WHERE config_key = 'theme'");
		mysql_query("UPDATE $table_configuration SET config_value = '$new_prot_theme' WHERE config_key = 'protected_theme'");
		mysql_query("UPDATE $table_configuration SET config_value = '$newsitename' WHERE config_key = 'sitename'");
		mysql_query("UPDATE $table_configuration SET config_value = '$newtagline' WHERE config_key = 'tagline'");
		mysql_query("UPDATE $table_configuration SET config_value = '$startsection' WHERE config_key = 'startsection'");
		mysql_query("UPDATE $table_configuration SET config_value = '$siteemail' WHERE config_key = 'email'");
		mysql_query("UPDATE $table_configuration SET config_value = '$sessioncode' WHERE config_key = 'sessioncode'");
		mysql_query("UPDATE $table_configuration SET config_value = '$meta_keywords' WHERE config_key = 'meta_keywords'");
		mysql_query("UPDATE $table_configuration SET config_value = '$meta_description' WHERE config_key = 'meta_description'");
		
		if (IsSet ($_POST['newsletter_email']))
		{
			$newsletter_email = $_POST['newsletter_email']; //save the admin email addres of the newsletter module.
			mysql_query("UPDATE $table_configuration SET config_value = '$newsletter_email' WHERE config_key = 'newsletter_admin_email'");
		}
		
		if (strrpos($siteurl, '/') != strlen($siteurl) - 1)
		{
			$siteurl .= '/';
		} //add last slash if not present
		mysql_query("UPDATE $table_configuration SET config_value = '$siteurl' WHERE config_key = 'url'");
		mysql_query("UPDATE $table_configuration SET config_value = '$serverpath' WHERE config_key = 'serverpath'");
		mysql_query("UPDATE $table_configuration SET config_value = '$userpath' WHERE config_key = 'user_path'");
	}
	
	if ($save == "environment")
	{
		$comma_separated = implode(",", $valid_types);
		mysql_query("UPDATE $table_configuration SET config_value = '$newlanguage' WHERE config_key = 'language'");
		mysql_query("UPDATE $table_configuration SET config_value = '$newdateformat' WHERE config_key = 'dateformat'");
		mysql_query("UPDATE $table_configuration SET config_value = '$editor_rows' WHERE config_key = 'htmlarea_editor_rows'");
		mysql_query("UPDATE $table_configuration SET config_value = '$editor_width' WHERE config_key = 'editor_width'");
		mysql_query("UPDATE $table_configuration SET config_value = '$num_pages' WHERE config_key = 'number_pupilpages'");
		mysql_query("UPDATE $table_configuration SET config_value = '$allow_javascript' WHERE config_key = 'allow_javascript'");
		mysql_query("UPDATE $table_configuration SET config_value = '$file_permissions' WHERE config_key = 'file_permissions'");
		mysql_query("UPDATE $table_configuration SET config_value = '$comma_separated' WHERE config_key = 'valid_file_extentions'");
	}
	
	if ($save == "personal")
	{
		$query = mysql_query("SELECT username FROM $table_users WHERE username = '$username' AND id != '$userid'");
		$results = mysql_num_rows($query);
		
		if ($results != '0') //an other user with this username exists, give error
		{
			print "<script language=\"Javascript\">
				   <!--
				   alert (\"" . $sas_lang['student_name_exists'] . "\");
				   window.location = 'index.php?option=configuration&suboption=personal' ;	
				   //-->
				   </script>"; //return to the user edit window.
		}
		else
		{
			if (($sas_config[use_encryption] == 1) AND ($password != "") AND ($password != "********")) //passwords are encrypted and not blank
			{
				$password = md5($password);
			}

			if (($password != "") AND ($password != "********")) //only save password when not empty.
			{
				mysql_query("UPDATE $table_users SET password = '$password' WHERE id = '$userid'");
			}

			mysql_query("UPDATE $table_users SET name = '$fullname' WHERE id = '$userid'");
			mysql_query("UPDATE $table_users SET username = '$username' WHERE id = '$userid'");
			mysql_query("UPDATE $table_users SET email = '$email' WHERE id = '$userid'");
			mysql_query("UPDATE $table_users SET editor = '$neweditor' WHERE id = '$userid'");
			$query = "SELECT location FROM $table_editors WHERE id = '$neweditor'"; // getting the editors location
			$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
			$_SESSION['editor_loc'] = mysql_result($result, 0);
			$_SESSION['editor'] = $neweditor;
			unset ($query);
			unset ($result);
		}
	}
}

include ("interface/header.inc.php");
include ("interface/menubar.inc.php");
include ("interface/menustart.inc.php");
include ("interface/menuend.inc.php");
include ("interface/pagestart.inc.php");

print "<span class=\"sas_module_title\">" . $sas_lang['configuration'] . "<br></span>";
print "" . $sas_lang['configuration_introduction'] . "</span>";

print "<p><table border=\"0\" width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\">
        <tr>
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=configuration\"><img border=\"0\" src=\"graphics/cfg-settings.gif\" width=\"48\" height=\"48\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=configuration\">" . $sas_lang['configuration2'] . "</a></span></td>
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=environment\"><img border=\"0\" src=\"graphics/cfg-environment.gif\" width=\"48\" height=\"48\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=environment\">" . $sas_lang['environment'] . "</span></td>
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=personal\"><img border=\"0\" src=\"graphics/cfg-personal.gif\" width=\"48\" height=\"48\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=personal\">" . $sas_lang['personalsettings'] . "</a></span></td>
        </tr>
        <tr>
          <td width=\"100%\" align=\"left\" valign=\"top\" colspan=\"3\"><br></td>
        </tr>
        <tr>
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=users\"><img border=\"0\" src=\"graphics/cfg-users.gif\" width=\"48\" height=\"48\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=users\">" . $sas_lang['users'] . "</a></span></td>
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=teachers\"><img border=\"0\" src=\"graphics/cfg-teachers.gif\" width=\"48\" height=\"48\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=teachers\">" . $sas_lang['teachers'] . "</span></td>
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=students\"><img border=\"0\" src=\"graphics/cfg-students.gif\" width=\"48\" height=\"48\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=students\">" . $sas_lang['students'] . " & " . $sas_lang['classes'] . "</a></span></td>           
        </tr>
        <tr>
          <td width=\"100%\" align=\"left\" valign=\"top\" colspan=\"3\"><br></td>
        </tr>
        <tr>          
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=projects\"><img border=\"0\" src=\"graphics/projects.gif\" width=\"48\" height=\"48\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=projects\">" . $sas_lang['student_projects'] . "</a></span></td>
          <td width=\"33%\" align=\"center\" valign=\"top\">
          <a href=\"index.php?option=configuration&suboption=alerts\"><img border=\"0\" src=\"graphics/cfg-alerts.gif\"></a><br>
          <span class=link><a href=\"index.php?option=configuration&suboption=alerts\">" . $sas_lang['alerts'] . "</a></span></td>
          <td width=\"33%\" align=\"center\" valign=\"top\">&nbsp;</td>
        </tr>
</table>";

include ("interface/pageend.inc.php");
include ("interface/footer.inc.php");
?>