<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 3.0.00
* Copyright (C) 2007-2011: Fred Stuurman (fc.stuurman@gmail.com)
* News module : 
* admin.php: last changed 08/08/2011 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

$modoption = "list_news_cat"; //default option
if (IsSet ($_GET['modoption']))
{
	$modoption = sanitize($_GET['modoption'], 15, 'S');
}
if (IsSet ($_GET['cat_id']))
{
	$cat_id = sanitize($_GET['cat_id'], 5 , 'I'); //sanitize, 5 pos max
}
if (IsSet ($_GET['article_id']))
{
	$article_id = sanitize($_GET['article_id'], 5 , 'I'); //sanitize, 5 pos max
}
if (IsSet ($_POST['content']))
{
	$content = sql_addslashes($_POST['content']);
}
if (IsSet ($_POST['article_category']))
{
	$article_category = intval($_POST['article_category']);
}
if (IsSet ($_POST['article_archive']))
{
	$article_archive = intval($_POST['article_archive']);
}
if (IsSet ($_POST['article_date']))
{
	$article_date = sanitize($_POST['article_date'], 15 , 'S');
	$article_date = convert_date($article_date); //put it in the form of %y-%m-%d
}
if (IsSet ($_POST['category_title']))
{
	$category_title = sanitize($_POST['category_title'], 40, 'S');
}
if (IsSet ($_POST['newtemplate']))
{
	$newtemplate = sanitize($_POST['newtemplate'], 15 , 'S');
}

if (IsSet ($_POST['welcome_text']))
{
	$welcome_text = sanitize($_POST['welcome_text'], 3000 , 'H'); //sanitize the input, leave html tags in tact
	$archive_welcome_text = sanitize($_POST['archive_welcome_text'], 3000 , 'H'); //sanitize the input, leave html tags in tact
}

if (IsSet ($_POST['ispage']))
{
	$ispage = intval($_POST['ispage']);
}

if (IsSet ($_POST['show_archive']))
{
	$show_archive = intval($_POST['show_archive']);
}

if (IsSet ($_POST['article_title']))
{
	$article_title = sanitize($_POST['article_title'], 80 , 'S'); //sanitize, 80 chars max
	$article_content = sanitize($_POST['article_content'], 0, 'H');
}
if (IsSet ($_POST['number_of_days']))
{
	$number_of_days = intval($_POST['number_of_days']);
}

load_language('', 'sn_news'); //load language file

$date_format = $sas_config['dateformat'];

$table_news_articles = $dbprefix . "m_news_articles";
$table_news_category = $dbprefix . "m_news_cat";

$query = "SELECT name FROM $table_modules WHERE id = '".$module."' LIMIT 1"; //get module name                 
$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
$modulename = mysql_result($result, 0);
unset ($query);
unset ($result);

include ("interface/header.inc.php");
print "
<script type=\"text/javascript\">
	$(document).ready(function() {
		$(\"#theForm\").validate(
		{
		errorLabelContainer: \"#ErrorBox\"
	}
		);
	});
	</script>";
	
include ("interface/menubar.inc.php");
include ("interface/menustart.inc.php");
print "<span class=\"sas_module_title\">" . $sas_lang['filemanager_menu'] . "</span><p>";
print "
	  <a href=\"index.php?option=modulemanager&module=$module&modoption=list_news_cat\">" . $sas_lang['news_module_headlines'] . "</a><p>
	  <a href=\"index.php?option=modulemanager&module=$module&modoption=list_news_cat&suboption=archive\">" . $sas_lang['news_module_archive'] . "</a><p>
	  <a href=\"index.php?option=modulemanager&module=$module&modoption=config\">" . $sas_lang['configuration'] . "</a><p></span>";
include ("interface/menuend.inc.php");
include ("interface/pagestart.inc.php");

print "<span class=\"sas_module_title\">$modulename</span><p>";

switch ($modoption) // start of switch
{
	case list_news_cat:
	
		if($suboption == "archive")
		{
			$archive = 1 ;
			print "<span class=\"sas_module_subtitle\">" . $sas_lang['news_module_archive'] . "</span><br><br>";
		}
		else
		{
			$archive = 0 ;
			print "<span class=\"sas_module_subtitle\">" . $sas_lang['news_module_headlines'] . "</span><p>";
		}
		
		$query = "SELECT id, title FROM $table_news_category"; // getting the categories     
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
		$Recordcount = mysql_num_rows($result); //number ofnews categories
		if ($Recordcount > 0)
		{
			while ($cat_list = mysql_fetch_array($result))
			{
				$query1 = "SELECT id FROM $table_news_articles WHERE category = '$cat_list[0]' AND archive = $archive";
				$result1 = mysql_query($query1) or trigger_error(mysql_error().'"<br>Query : "' . $query1 . '".',E_USER_WARNING); 
				$count = mysql_num_rows($result1); //number ofnews itemss
				
				print "<table><tr><td>";
	
				print "<img border=\"0\" src=\"graphics/delete.gif\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\" width=\"16\" height=\"16\" class=\"tooltip\"  
				onClick=\"if(confirm('" . $sas_lang['news_module_deletecategory_confirm'] . "')) parent.location='index.php?option=modulemanager&suboption=$suboption&module=$module&modoption=delete_category&cat_id=$cat_list[0]';\">";
	
				print "</td>
						<td>";
				print "<img border=\"0\" src=\"graphics/edit.gif\" alt=\"" . $sas_lang['edit'] . "\" title=\"" . $sas_lang['edit'] . "\" width=\"16\" height=\"16\" class=\"tooltip\"  
						onClick=\"parent.location='index.php?option=modulemanager&module=$module&modoption=edit_category&suboption=$suboption&cat_id=$cat_list[0]'\">
						&nbsp;".$sas_lang['category']."</span>&nbsp;:
						<a href=\"index.php?option=modulemanager&module=$module&suboption=$suboption&cat_id=$cat_list[0]\">$cat_list[1]</a></span><span class=\"sas_module_lbl1\"> ($count)</span>";
	
				print "</td></tr></table><br>";
				
				if ($cat_list[0] == $cat_id)
				{
					print "<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\">";
					
					// getting the news articles
					$query1 = "SELECT id, date_format(date, '$date_format') AS Readable_Date, title, public FROM $table_news_articles WHERE category = '$cat_list[0]' AND (archive = '$archive' ) ORDER BY date DESC"; 
					$result1 = mysql_query($query1) or trigger_error(mysql_error().'"<br>Query : "' . $query1 . '".',E_USER_WARNING); 
					
					while ($news_list = mysql_fetch_array($result1))
					{
						print "<tr>                                                    
								<td>&nbsp;</td>
								<td>";
		
						print "<img border=\"0\" src=\"graphics/delete.gif\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\" width=\"16\" height=\"16\" class=\"tooltip\"  
						onClick=\"if(confirm('" . $sas_lang['news_module_deletearticle_confirm'] . "')) parent.location='index.php?option=modulemanager&module=$module&modoption=delete_article&suboption=$suboption&article_id=$news_list[0]';\">";
		
						print "</td>
								<td>";
		
						print "<img border=\"0\" src=\"graphics/edit.gif\" alt=\"" . $sas_lang['edit'] . "\" title=\"" . $sas_lang['edit'] . "\" width=\"16\" height=\"16\" class=\"tooltip\"  
						onClick=\"parent.location='index.php?option=modulemanager&module=$module&modoption=edit_article&suboption=$suboption&cat_id=$cat_id&article_id=$news_list[0]'\">";
		
						print "</td>
								 <td>
								 <img border=\"0\" src=\"graphics/document.gif\">
								 </td>
								 <td><a href=\"index.php?option=modulemanager&module=$module&modoption=edit_article&suboption=$suboption&cat_id=$cat_id&article_id=$news_list[0]\">$news_list[1] - $news_list[2]";
						
						if ($news_list[3] == "1") //news for protected area
						{
							print "&nbsp;&nbsp; (*)";
							$is_on_prot_area = 1;
						}
						print "</a></span></td>
											</tr>";
					}
					print "</table><br>";
				}
			}
		}
		else
		{
			print "<p>" . $sas_lang['news_module_addcategory_please'] . "</span>";
		}
	
		print "<table>";
		
		if ($is_on_prot_area == 1) //news for protected area
		{
			print "<tr><td colspan=\"3\">&nbsp;<span class=\"sas_module_lbl2\">(*) " . $sas_lang['protected_area'];
		}
		
		if ($Recordcount > 0)
		{
			print "</td></tr><tr>
					  <td colspan=\"3\">&nbsp;</td>
					</tr>
					<tr>
					  <td>&nbsp;</td>
					  <td><img border=\"0\" src=\"graphics/add.gif\">
					  </td>
					  <td><a href=\"index.php?option=modulemanager&module=$module&modoption=add_article&cat_id=$cat_id&article_id=0\">" . $sas_lang['news_module_addarticle'] . "</a>
					  ";
		}
		print "<img border=\"0\" src=\"graphics/add.gif\">&nbsp;<a href=\"index.php?option=modulemanager&module=$module&modoption=add_category&cat_id=0\">" . $sas_lang['news_module_addcategory'] . "</a></td>
				</tr>
				</table>";
		print "\n<p><button onclick=\"javascript:parent.location='index.php?option=modulemanager'\" type=\"button\" class=\"button\"><em><span>".$sas_lang['goback']."</em></span></button>";
	break;
	
	case config:
		
		print "<span class=\"sas_module_subtitle\">" . $sas_lang['configuration'] . "<p></span>";
		print "<FORM METHOD=\"POST\" id=newarticle ACTION=\"index.php?option=modulemanager&module=$module&modoption=save_config\">";

		print "<table cellspacing=\"2\" cellpadding=\"2\" width=\"640\" bgcolor=\"#CECECE\">";

		print "<tr><td colspan=\"2\" class=\"sas_row_color_even\">" . $sas_lang['news_module_welcometext'] . ": &nbsp;</span></td></tr>
				<tr><td colspan=\"2\" bgcolor=\"#F7F7F7\">";

		small_editor('welcome_text', $sas_config['news_welcome_text'], 'editor1');
		
		print "</td></tr>";

		print "<tr><td colspan=\"2\" class=\"sas_row_color_even\">" . $sas_lang['news_module_archive'] . " " . $sas_lang['news_module_welcometext'] . ": &nbsp;</span></td></tr>
				<tr><td colspan=\"2\" bgcolor=\"#F7F7F7\">";

		small_editor('archive_welcome_text', $sas_config['news_archive_welcome_text'], 'editor2');
		
		print "</td></tr>";
		print "<tr><td class=\"sas_row_color_even\">" . $sas_lang['news_module_template'] . ":</td>";
		print "<td class=\"sas_row_color_even\"><select size=\"1\" name=\"newtemplate\">\n";
		$custompath = $serverpath . "/modules/sn_news/templates";
		$dir_handle = @ opendir($custompath) or die("Unable to open $custompath");
		
		while ($file = readdir($dir_handle))
		{
			if ($file != ".." AND $file != ".")
			{
				if ($file == $sas_config['news_template'])
				{
					echo "<option selected value=\"$file\">$file</option>";
				}
				else
				{
					echo "<option value=\"$file\">$file</option>";
				}
			}
		}
		closedir($dir_handle);
		print "</select></td></tr></table>";
		print "\n<br><button onclick=\"javascript:parent.location='index.php?option=modulemanager&module=$module'\" type=\"button\" class=\"button\"><em><span>".$sas_lang['goback']."</em></span></button>";
		print "\n&nbsp;<button type=\"submit\" class=\"button\"><em><span>".$sas_lang['save']."</em></span></button>";
		print "</span></form>";

	break;
	
	case save_config:

		mysql_query("UPDATE $table_configuration SET config_value = '$newtemplate' WHERE config_key = 'news_template'");
		mysql_query("UPDATE $table_configuration SET config_value = '$welcome_text' WHERE config_key = 'news_welcome_text'");
		mysql_query("UPDATE $table_configuration SET config_value = '$archive_welcome_text' WHERE config_key = 'news_archive_welcome_text'");
		print "<script language='javascript'>window.location = 'index.php?option=modulemanager&module=$module&modoption=list_news_cat'</script>";
		
	break;


	case add_article:

		$date1 = time();
		$article_date = strftime($sas_config['dateformat'], $date1);
		//editor
		include ("modules/sn_news/edit_content.php");
	
	break;


	case add_category:
		
		print "<span class=\"sas_module_subtitle\">" . $sas_lang['news_module_addcategory'] . "<br></span>";
		print "<div id=\"ErrorBox\"></div>";
		print "<FORM name=\"theForm\" id=\"theForm\" METHOD=\"POST\" id=newarticle ACTION=\"index.php?option=modulemanager&module=$module&modoption=save_category&cat_id=0\">";
  
		print "<table cellspacing=\"2\" cellpadding=\"2\" width=\"640\" bgcolor=\"#CECECE\">";
        print "<tr><td class=\"sas_row_color_even\">" . $sas_lang['title'] . " (*):</td><td class=\"sas_row_color_even\">
				<input type=text name=\"category_title\" size=\"40\" class=\"required\" />&nbsp;<img src=graphics/help.gif ONMOUSEOVER=\"popup('" . $sas_lang['news_module_categorytitle_tip'] . "','CCDAEC')\"; ONMOUSEOUT=\"kill()\"></td></tr>";
		
		print "<tr><td colspan=\"2\" class=\"sas_row_color_even\">" . $sas_lang['news_module_welcometext'] . ": &nbsp;</span></td></tr>
				<tr><td colspan=\"2\" bgcolor=\"#F7F7F7\">";

		// call basic fck editor for welcome text
		small_editor('welcome_text', "", 'editor1');
		
		print "</td></tr>";
			   
		print "<tr><td class=\"sas_row_color_even\">". $sas_lang['news_module_category_is_page'] . "&nbsp;&nbsp;</span></td>
				<td class=\"sas_row_color_even\">" . $sas_lang['yes'] . "</span>";
				
		print "<input type=\"radio\" value=\"1\" name=\"ispage\">";
		print "&nbsp;&nbsp;&nbsp; " . $sas_lang['no'] . "</span>";
		print "<input type=\"radio\" name=\"ispage\" value=\"0\" checked></td></tr>";
		
		print "<tr><td class=\"sas_row_color_even\">". $sas_lang['news_module_show_archive'] . "&nbsp;&nbsp;</span></td>
				<td class=\"sas_row_color_even\">" . $sas_lang['yes'] . "</span>";
				
		print "<input type=\"radio\" value=\"1\" name=\"show_archive\">";
		print "&nbsp;&nbsp;&nbsp; " . $sas_lang['no'] . "</span>";
		print "<input type=\"radio\" name=\"show_archive\" value=\"0\" checked></td></tr>";
		
		print "<tr><td class=\"sas_row_color_even\">" . $sas_lang['news_module_number_of_days'] . " :</span></td>
				<td class=\"sas_row_color_even\"><input type=\"text\" name=\"number_of_days\" size=\"5\" value=\"0\" class=\"textfield\"></td></tr>";
		print "<tr><td class=\"sas_row_color_even\" colspan=\"4\"><span class=\"sas_module_lbl2\">" . $sas_lang['required_fields'] . "</td></tr>
				</table>\n";
		
		print "\n<p><button onclick=\"javascript:parent.location='index.php?option=modulemanager&module=$module'\" type=\"button\" class=\"button\"><em><span>".$sas_lang['goback']."</em></span></button>";
		print "\n&nbsp;<button type=\"submit\" class=\"button\"><em><span>".$sas_lang['save']."</em></span></button>";
		print "</span></form>";

	break;
	
	case edit_category:
		
		$query = "SELECT title, ispage, header, number_of_days, show_archive FROM $table_news_category WHERE id = '".$cat_id."'"; // getting the category     
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
		$category_title = mysql_result($result, 0, 'title');
		$ispage_check = mysql_result($result, 0, 'ispage');
		$welcome_text = mysql_result($result, 0, 'header');
		$number_of_days = mysql_result($result, 0, 'number_of_days');
		$show_archive = mysql_result($result, 0, 'show_archive');
		unset ($query);
		unset ($result);
		
		print "<span class=\"sas_module_subtitle\">" . $sas_lang['news_module_editcategory'] . "<br></span>";
		print "<FORM METHOD=\"POST\" ACTION=\"index.php?option=modulemanager&module=$module&modoption=save_category&cat_id=$cat_id\">";

		print "<table cellspacing=\"2\" cellpadding=\"2\" width=\"640\" bgcolor=\"#CECECE\">";

        print "<tr><td class=\"sas_row_color_even\">" . $sas_lang['title'] . ":</td><td class=\"sas_row_color_even\">
				<input type=text name=\"category_title\" size=40 class=\"textfield\" value=\"$category_title\">&nbsp;<img src=graphics/help.gif 
				ONMOUSEOVER=\"popup('" . $sas_lang['news_module_categorytitle_tip'] . "','CCDAEC')\"; ONMOUSEOUT=\"kill()\"></td></tr>";
		
		print "<tr><td colspan=\"2\" class=\"sas_row_color_even\">" . $sas_lang['news_module_welcometext'] . ": &nbsp;</span></td></tr>
				<tr><td colspan=\"2\" bgcolor=\"#F7F7F7\">";

		//call basic editor for welcome text
		small_editor('welcome_text', $welcome_text, 'editor1');
		
		print "</td></tr>";
		
		print "<tr><td class=\"sas_row_color_even\">". $sas_lang['news_module_category_is_page'] . "&nbsp;&nbsp;</span></td>
				<td class=\"sas_row_color_even\">" . $sas_lang['yes'] . "</span>";

		if ($ispage_check == "1")
		{
			print "<input type=\"radio\" value=\"1\" name=\"ispage\" checked>";
			print "&nbsp;&nbsp;&nbsp; " . $sas_lang['no'] . "</span>";
			print "<input type=\"radio\" name=\"ispage\" value=\"0\"></td></tr>";
		}
		else
		{
			print "<input type=\"radio\" value=\"1\" name=\"ispage\">";
			print "&nbsp;&nbsp;&nbsp; " . $sas_lang['no'] . "</span>";
			print "<input type=\"radio\" name=\"ispage\" value=\"0\" checked></td></tr>";
		}
		
		print "<tr><td class=\"sas_row_color_even\">". $sas_lang['news_module_show_archive'] . "&nbsp;&nbsp;</span></td>
				<td class=\"sas_row_color_even\">" . $sas_lang['yes'] . "</span>";

		if ($show_archive == "1")
		{
			print "<input type=\"radio\" value=\"1\" name=\"show_archive\" checked>";
			print "&nbsp;&nbsp;&nbsp; " . $sas_lang['no'] . "</span>";
			print "<input type=\"radio\" name=\"show_archive\" value=\"0\"></td></tr>";
		}
		else
		{
			print "<input type=\"radio\" value=\"1\" name=\"show_archive\">";
			print "&nbsp;&nbsp;&nbsp; " . $sas_lang['no'] . "</span>";
			print "<input type=\"radio\" name=\"show_archive\" value=\"0\" checked></td></tr>";
		}
		
		print "<tr><td class=\"sas_row_color_even\">" . $sas_lang['news_module_number_of_days'] . " :</span></td>
				<td class=\"sas_row_color_even\"><input type=\"text\" name=\"number_of_days\" size=\"5\" value=\"$number_of_days\" class=\"textfield\"></td></tr>
				</table>\n";
		
		print "\n<p><button onclick=\"javascript:parent.location='index.php?option=modulemanager&module=$module&modoption=list_news_cat'\" type=\"button\" class=\"button\"><em><span>".$sas_lang['goback']."</em></span></button>";
		print "\n&nbsp;<button type=\"submit\" class=\"button\"><em><span>".$sas_lang['save']."</em></span></button>";
		print "</form>";

	break;
	
	case edit_article:

		//2.5.01
		$query = "SELECT title, content, date_format(date, '$date_format') AS Readable_Date, category, archive, public FROM $table_news_articles WHERE id = '".$article_id."'"; // getting the article
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
		$article_title = htmlspecialchars(mysql_result($result, 0, 0));
		$article_content = mysql_result($result, 0, 1);
		$article_date = mysql_result($result, 0, 2);
		$article_category = mysql_result($result, 0, 3);
		$article_archive = mysql_result($result, 0, 4);
		$article_public = mysql_result($result, 0, 5);
		unset ($query);
		unset ($result);
	
		//editor
		include ("modules/sn_news/edit_content.php");

	break;

	case save_article:

		if (($article_archive == 0) OR ($article_archive == 3))
		{
			$archive = 0;
			if ($article_archive == 3)
			{
				$is_public = 1;
			}
			else
			{
				$is_public = 0;
			}
		}
		if (($article_archive == 1) OR ($article_archive == 2))
		{
			$archive = 1;
			if ($article_archive == 2)
			{
				$is_public = 1;
			}
			else
			{
				$is_public = 0;
			}
		}
		
		//get title and number_of_days
		$result = mysql_query("SELECT title, number_of_days FROM $table_news_category WHERE id = '".$article_category."'"); //find the title of category
		$page_name = mysql_result($result, 0, 0);
		$number_of_days = mysql_result($result, 0, 1);
		
		if ($article_id == 0)
		{
			mysql_query("INSERT INTO $table_news_articles (id, title, date, category, content, archive, public, todate) 
			   VALUES (NULL, '$article_title', '$article_date', '$article_category', '$article_content', '$archive', '$is_public', DATE_ADD(NOW(),INTERVAL $number_of_days DAY))");
		}
		else
		{
			mysql_query("UPDATE $table_news_articles 
							SET title = '$article_title', 
								date = '$article_date', 
								content = '$article_content', 
								category = '$article_category', 
								archive = '$archive',
								public = '$is_public',
								todate = DATE_ADD('$article_date',INTERVAL $number_of_days DAY)  
							WHERE id = '".$article_id."'");
		}
	
		
		//send alert and update change date
		$result2 = mysql_query("SELECT id, section, lastupdate, name FROM $table_pages WHERE module = 'sn_news/frontpage_cat.php' AND name = '".$page_name."' ");
		if (mysql_num_rows($result2) == 0)
		{
			$result2 = mysql_query("SELECT id, section, lastupdate, name FROM $table_pages WHERE module = 'sn_news/frontpage.php' ");
		}
		if (mysql_num_rows($result2) > 0)
		{
			$d = date("Y-m-d H:i:s"); //todays date
			$change_date = mysql_result($result2, 0, 2);
			$savepage = mysql_result($result2, 0, 0);
			$section = mysql_result($result2, 0, 1);
			$title = mysql_result($result2, 0, 3);
			mysql_query("UPDATE $table_pages SET lastupdate='$d' WHERE id='$savepage'");
	
			if ($change_date < $d) //send alerts only the first time on a date 
			{
				include ("core/send_alerts.php"); //check to see if need to send alerts  
			}
		}
		//go back to the news list.
		print "<script language='javascript'>window.location = 'index.php?option=modulemanager&module=$module&modoption=list_news_cat&suboption=$suboption&cat_id=$article_category'</script>";
	
	break;

	case save_category:

		if ($cat_id == 0)	//when $cat_id is 0 we have a new news category
		{
			mysql_query("INSERT INTO $table_news_category (id, title, ispage, header, number_of_days, show_archive) " .
					"VALUES (NULL, '$category_title', '$ispage', '$welcome_text', '$number_of_days', '$show_archive')");
		}
		else
		{
			mysql_query("UPDATE $table_news_articles SET todate = DATE_ADD(date, INTERVAL $number_of_days DAY) WHERE category = '".$cat_id."'") ;
			mysql_query("UPDATE $table_news_category 
							SET title = '$category_title', ispage = '$ispage', 
							header = '$welcome_text', 
							number_of_days = '$number_of_days',
							show_archive = '$show_archive'
							WHERE id = '".$cat_id."'");
		}
		print "<script language='javascript'>window.location = 'index.php?option=modulemanager&module=$module&modoption=list_news_cat'</script>";
		
	break;

	case delete_article:

		mysql_query("DELETE from $table_news_articles WHERE id = '".$article_id."'");
		print "<script language='javascript'>window.location = 'index.php?option=modulemanager&module=$module&modoption=list_news_cat'</script>";
	
	break;

	case delete_category:

		mysql_query("DELETE FROM $table_news_articles WHERE category = '".$cat_id."	'"); //delete articles for this category
		mysql_query("DELETE FROM $table_news_category WHERE id = '".$cat_id."'");	//delete category itself
		
		print "<script language='javascript'>window.location = 'index.php?option=modulemanager&module=$module&modoption=list_news_cat'</script>";
		
	break;
}

include ("interface/pageend.inc.php");
include ("interface/footer.inc.php");
?>
