<?php
#################################################################################
#               Mail function of the newsletter module 
# This function uses the phpmailer class (included in de admin.php, if you want to use a different
# mail method you can replace the newsletter_mail function by your own.
# 
############################################################################
# mail_function2.php: last changed 22/11/2007  , version: 2.5.04
#                  by Fred Stuurman (fc.stuurman@gmail.com)
#$Id: mail_function2.php,v 1.1 2007/11/22 10:33:56 fstuurman Exp $
############################################################################
if ( !defined('IN_SAS') )
{
	die("Hacking attempt");
}

function newsletter_mail($email_list,$content,$owner_email,$subject) 
{
//the $email_list is an array with all the emails we are going to sent the newsletter
//$email_list = ontains the actual emails as array
//$content =  actual newsletter content, contains the link when send_link = 1
//$owner_email = this is the email address of the of newsletter owner
//$subject = contains the subject for the emails

global $sas_lang, $newsletter_name, $sas_config;

$content_to_send = "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
			<html>
			<head>
			<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . $sas_lang['lang_charset'] . "\">
			<title>$newsletter_name</title>";
			
if(file_exists("themes/".$sas_config['theme']."/style.css"))
{
	$css = "<style type=\"text/css\">";
	$lines = file("themes/".$sas_config['theme']."/style.css");
	
	foreach($lines as $value)
	{
		$css .= $value ;
	}
	
	$css .= "</style>";
	$content_to_send .= $css ;
}
$content_to_send .=	"</head><body>".$content."</body></html>" ;
$content_to_send = wordwrap($content_to_send) ;

$mail = new PHPMailer();
$mail->CharSet = $sas_lang['lang_charset'] ;
$mail->From = $owner_email;
$mail->FromName = $sas_config['sitename'];
$mail->Subject = $subject;
$mail->Body = $content_to_send;
$mail->IsHTML(true);

$number = count($email_list) ;                          //number of emails to process
$i = 0 ;

	while ($i < $number)
	{
		// Check for safe mode
		if( !ini_get('safe_mode') )
		{
			@set_time_limit(30) ;
		}
		$mail->AddAddress($email_list[$i]);
		$mail->Send() ;
		$i++;  
		$mail->ClearAddresses();
	}
return $number;
}
?>